﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	Private f_Owner As Object
	Private mPt() As Point
	Private POV As Double	'Point of View
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(f As Object)
	f_Owner = f
	
End Sub

Public Sub Change_Points(p() As Point, PV As Double)
	mPt = p
	POV = PV
	RotateCoordinatesX(1.2)
    RotateCoordinatesY(0.30)'(0.665)
    RotateCoordinatesZ(1.2)
    Conclusion
End Sub

Private Sub RotateCoordinatesX(Angle As Double)
    Dim NewY As Double, NewZ As Double
    For i = 0 To mPt.Length-1
		NewY = mPt(i).Y * Cos(Angle) - mPt(i).Z * Sin(Angle)
        NewZ = mPt(i).Y * Sin(Angle) + mPt(i).Z * Cos(Angle)
        mPt(i).Y = NewY
       mPt(i).Z = NewZ
    Next 
End Sub

Private Sub RotateCoordinatesY(Angle As Double)
    Dim NewX As Double, NewZ As Double
	For i = 0 To mPt.Length-1
	    NewX = mPt(i).Z * Sin(Angle) + mPt(i).X * Cos(Angle)
	    NewZ = mPt(i).Z * Cos(Angle) - mPt(i).X * Sin(Angle)
	    mPt(i).X = NewX
	    mPt(i).Z = NewZ
	Next 
End Sub

Private Sub RotateCoordinatesZ(Angle As Double)
    Dim NewX As Double, NewY As Double
    For i = 0 To mPt.Length-1
        NewX = mPt(i).X * Cos(Angle) - mPt(i).Y * Sin(Angle)
        NewY = mPt(i).X * Sin(Angle) + mPt(i).Y * Cos(Angle)
        mPt(i).X = NewX
        mPt(i).Y = NewY
    Next 
End Sub

Sub Conclusion()
    For i = 0  To mPt.Length - 1
		mPt(i).X = mPt(i).X * POV / (POV + mPt(i).Z)
		mPt(i).Y = mPt(i).Y * POV / (POV + mPt(i).Z)
    Next 
	CallSubDelayed(f_Owner, "Return_Points")
End Sub

